package com.dianafisher.chapter1;


import junit.framework.TestCase;

/**
 * Question 1.8 - Assume you have a method isSubstring which checks if one word is a substring of another.
 *      Given two strings, s1 and s2, write code to check if s2 is a rotation of s1 using only one call to isSubstring.
 *
 * Assumptions:
 * */
public class CheckRotation extends TestCase
{

    /**
     * returns true if b is a substring of a
     * */
    private boolean isSubstring( String a, String b )
    {
        System.out.println(String.format("checking if %s contains %s", a, b ));
        return a.contains( b );
    }

    public boolean isRotation( String str1, String str2 )
    {
        // first check if the strings are equal to each other.  Assume equal strings are not considered 'rotations' and return false.
        if( str1.equals( str2 )) return false;
        // return false if either string is of zero length
        if( str1.length() == 0 ) return false;
        if( str2.length() == 0 ) return false;
        // return false if the strings do not have the same length
        if( str1.length() != str2.length() ) return false;

        int i = 0;
        int j = 0;
        // scan for matching strings
        while( str1.charAt(i) == str2.charAt(j))
        {
            // increase both and see if they match
            if( i > str1.length()-1 || j > str2.length()-1 ) break;
        }
        System.out.println(String.format("found non-matching characters at i = %d, j = %d",i, j));
//        // get the first character of str1 and see where it is in str2
//        char begin1 = str1.charAt(0);
//        char end2 = str2.charAt(str2.length()-1);
//        System.out.println(String.format("First character of str1 is %c, last character of str2 is %c", begin1, end2));
//        if( begin1 == end2 ) return isSubstring( str1, str2.substring(0, str2.length()-1));
        return false;
    }

    public void test()
    {
//        assertTrue( isRotation( "waterwottle", "aterwottlew" ));
//        assertTrue( isRotation( "waterwottle", "terwottlewa" ));
//        assertTrue( isRotation( "waterwottle", "erwottlewat" ));
//        assertTrue( isRotation( "waterwottle", "rwottlewate" ));
//        assertTrue( isRotation( "waterwottle", "wottlewater" ));
//        assertTrue( isRotation( "waterwottle", "ottlewaterw" ));
//        assertTrue( isRotation( "waterwottle", "ttlewaterwo" ));
        assertTrue( isRotation( "waterwottle", "tlewaterwot" ));
//        assertTrue( isRotation( "waterwottle", "lewaterwott" ));
//        assertTrue( isRotation( "waterwottle", "ewaterwottl" ));
//        assertTrue( isRotation( "waterbottle", "aterbottlew" ));
//        assertTrue( isRotation( "waterbottle", "ewaterbottl" ));
//        assertTrue( isRotation( "waterbottle", "erbottlewat" ));
//        assertTrue( isRotation( "waterbottle", "terbottlewa" ));
//        assertFalse(isRotation("waterbottle", "erbottlefat"));
//        assertFalse(isRotation("waterbottle", "erbtotlewat"));
//        assertTrue( isRotation( "cat", "atc" ));
    }
}
