package com.dianafisher.chapter1;

import junit.framework.TestCase;

/**
 * Question 1.4 - Write a method to replace all spaces in a string with '%20'.
 *
 * Assumptions:
 *      * The string has sufficient space at the end to hold the additional characters.
 * */
public class InPlaceReplacement extends TestCase
{

    public String escape( String str )
    {
        // use a character array so the replacement can be done in place.
        char[] array = str.toCharArray();

//        System.out.println("array.length = " + array.length);
//        String expected = "Mr%20John%20Smith";
//        System.out.println("expected.length() = " + expected.length());
//
        for( int i = 0; i < array.length; i++ )
        {
//            System.out.println("array[" + i + "] = " + array[i]);
            if( array[i] == ' ' )
            {
//                System.out.println("found space at index:" + i);
                // start j at the end of the array and work backwards

                int j = array.length - 1;
                while( array[j] == ' ' && j > i )
                {
                    // decrease j until we come to a character
                    j--;
                }
//                System.out.println("j = " + j);
                // move all of the characters down two slots
                while( j > i )
                {
                    array[j+2] = array[j];
                    j--;
                }
//                System.out.println("after moving down two spaces: " + new String(array));
                // replace space with '%20'
                array[i] = '%';
                array[i+1] = '2';
                array[i+2] = '0';
//                System.out.println("after replacement: " + new String(array));
            }

        }
        System.out.println("returning: " + new String(array));
        return new String(array);
    }

    public void test()
    {
        assertTrue( escape("Mr John Smith    ").equals( "Mr%20John%20Smith"));
    }
}
